
--recordes your bag and inventory data
function YGS_BAG_PARSE()
	YssGuildShop.db.char.YGSBAG={}
	for b=0,4 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop:Print(GetContainerItemLink(b,s)) -- debugline
				local _, itemCount = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YssGuildShop.db.char.YGSBAG[itemID] then
					YssGuildShop.db.char.YGSBAG[itemID] = YssGuildShop.db.char.YGSBAG[itemID] + itemCount
				else
					YssGuildShop.db.char.YGSBAG[itemID] = itemCount
				end
			end
		end
	end
	for inv=1,19 do
		if (GetInventoryItemLink("player",inv)) then
			--YssGuildShop:Print(GetContainerItemLink(b,s)) -- debugline
			local itemCount = GetInventoryItemCount("player",inv)
			local itemID = YssGuildShop_itemID_c(GetInventoryItemLink("player",inv))
			if YssGuildShop.db.char.YGSBAG[itemID] then
				YssGuildShop.db.char.YGSBAG[itemID] = YssGuildShop.db.char.YGSBAG[itemID] + itemCount
			else
				YssGuildShop.db.char.YGSBAG[itemID] = itemCount
			end
		end
	end
	if YssGuildShop.db.char.YGSBANK and YssGuildShop.db.char.YGSBAG then
		--YssGuildShop:Print("Merge Scheduled") -- debugline
		YGS_BANK_BAG_MERGE()
	end
end

-- records your bank data
function YGS_BANK_PARSE()
	YssGuildShop.db.char.YGSBANK = {}
	local b = BANK_CONTAINER
        for s=1,GetContainerNumSlots(b) do 
		if (GetContainerItemLink(b,s)) then
			local _, itemCount = GetContainerItemInfo(b,s)
			local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
			if YssGuildShop.db.char.YGSBANK[itemID] then
				YssGuildShop.db.char.YGSBANK[itemID] = YssGuildShop.db.char.YGSBANK[itemID] + itemCount
			else
				YssGuildShop.db.char.YGSBANK[itemID] = itemCount
			end
		end
        end
        for b=5,11 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local _, itemCount = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YssGuildShop.db.char.YGSBANK[itemID] then
					YssGuildShop.db.char.YGSBANK[itemID] = YssGuildShop.db.char.YGSBANK[itemID] + itemCount
				else
					YssGuildShop.db.char.YGSBANK[itemID] = itemCount
				end
			end
		end
        end
end

-- merges bank/bag/inventory data
function YGS_BANK_BAG_MERGE()
	--YssGuildShop:Print("Merging.......") -- debugline
	local YGS_LOCAL_DB = {}
	local uniquecheck = 0
	
	if YssGuildShop.db.char.YGSBAG then
		if YssGuildShop.db.char.YGSBANK then
			for itemID, value in pairs(YssGuildShop.db.char.YGSBANK) do
				YssGuildShop_share_value(itemID)
				YssGuildShop_item_db(itemID)
				table.insert(YGS_LOCAL_DB,{itemID , value})
			end
			for itemID, value in pairs(YssGuildShop.db.char.YGSBAG) do
				for i,v in ipairs(YGS_LOCAL_DB) do
					if tostring(v[1]) == tostring(itemID) then
						YGS_LOCAL_DB[i][2] = "[" .. value .. "/" .. v[2] .. "/" .. (v[2] + value) .. "]"
						uniquecheck = 1
					end
				end
				if uniquecheck == 0 then
					YssGuildShop_share_value(itemID)
					YssGuildShop_item_db(itemID)
					table.insert(YGS_LOCAL_DB,{itemID , "["..value.."/0/"..value.."]"})
				end
				uniquecheck = 0
			end
			for i,v in ipairs(YGS_LOCAL_DB) do
				if string.gsub (v[2], "%[.*%]", "true") ~= "true" then
					YGS_LOCAL_DB[i][2] = "[0/"..v[2].."/"..v[2].."]"
				end
			end
		end
	end
	
	table.sort(YGS_LOCAL_DB, function(a,b) return YssGuildShop_itemID_d(a[1])<YssGuildShop_itemID_d(b[1]) end)
	uniquecheck = 0
	YGS_LOCAL_DB["YGS_ID"] = YssGuildShop:YGS_ID()
	if YssGuildShop.db.account.YGSDB and YssGuildShop.db.account.YGSDB ~= {} then
		for k,v in ipairs(YssGuildShop.db.account.YGSDB) do
		--for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
			if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == YGS_LOCAL_DB["YGS_ID"][1] and v["YGS_ID"][4] == YGS_LOCAL_DB["YGS_ID"][4] then
				YssGuildShop.db.account.YGSDB[k] = YGS_LOCAL_DB
				uniquecheck = 1
			end
		end
		if uniquecheck == 0 then
			table.insert(YssGuildShop.db.account.YGSDB, YGS_LOCAL_DB)
		end
	else
		YssGuildShop.db.account.YGSDB = {}
		YssGuildShop.db.account.YGSDB[1] = YGS_LOCAL_DB
	end
	YssGuildShop:Send()
end

--adds items to YssGuildShop.db.char.YGS_share filter and YssGuildShop.db.char.YGS_value
function YssGuildShop_share_value(itemID, value, timestamp)
	if YssGuildShop.db.char.YGS_value[itemID] == nil then
		if value then
			YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
		else
			YssGuildShop.db.char.YGS_value[itemID] = {}
			YssGuildShop.db.char.YGS_value[itemID][1] = "no value set"
		end
	else
		if YssGuildShop.db.char.YGS_value[itemID][1] == "no value set" then
			if value then
				YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
			else
				YssGuildShop.db.char.YGS_value[itemID] = {}
				YssGuildShop.db.char.YGS_value[itemID][1] = "no value set"
			end
		elseif timestamp then
			if YssGuildShop.db.char.YGS_value[itemID][2] < timestamp then
				YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
			end
		end
	end
	if YssGuildShop.db.char.YGS_share_filter[itemID] == nil then
		YssGuildShop.db.char.YGS_share_filter[itemID] = rawget(YssGuildShop.db.char.YGS_settings ,2)
	end
end

function YssGuildShop_share_set(bvalue)
	for itemID, value in pairs(YssGuildShop.db.char.YGS_share_filter) do
		YssGuildShop.db.char.YGS_share_filter[itemID] = bvalue
	end
	YGS_Filter_ScrollBar_Update()
end

--itemID compression decompression and retrival functions

-- compressiong
function YssGuildShop_itemID_c(link)
	if not link then return end
	local _, _, itemID, _, _, _, _, _, suffixID, uniqueID = string.find(link, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)")
	if tonumber(suffixID) ~= 0 then
		itemID = itemID..":"..suffixID..":"..uniqueID
	end
	return itemID
end

--decompression to name
function YssGuildShop_itemID_d(item)
	if( not item ) then return nil end
	local _, _, itemID, suffixID, uniqueID = string.find(item, "(%-?%d+):(%-?%d+):(%-?%d+)")
	if suffixID then
		item = "item:"..itemID..":0:0:0:0:0:"..suffixID..":"..uniqueID
	end
	local itemName = GetItemInfo(item) 
	return itemName
end

--decompression to itemLink
function YssGuildShop_itemID_L(item)
	if( not item ) then return nil end
	local _, _, itemID, suffixID, uniqueID = string.find(item, "(%-?%d+):(%-?%d+):(%-?%d+)")
	if suffixID then
		item = "item:"..itemID..":0:0:0:0:0:"..suffixID..":"..uniqueID
	end
	local _, itemLink = GetItemInfo(item) 
	return itemLink
end

function YssGuildShop_item_db(itemID)
	if YssGuildShop.db.char.YGS_value[itemID] == nil then
		YssGuildShop.db.char.YGS_value[itemID] = {false,""}
	end
end
